/***************************************************************************
* Golden Gun AM Plugin for use with StatsMe (v2.6.2 or higher) MetaMod plugin and Counter-Strike 1.5.
* By: F117Bomb 
* Contact: TheJew@socal.rr.com 
*
* ADMIN COMMANDS:
*	admin_showdamage: Toggles Bullet Damage Status ON and OFF.
*	admin_goldengun <playername>: Toggles Golden Gun Mode for player. 
*
* EXPLANATION:
* 	admin_showdamage: When showdamage is on the damage from each bullet you shoot 
*	at someone is displayed right below your crosshair. 
*	
* 	admin_goldengun: When Golden Bullet Mode is on a certain player, 1 shot from 
*	any of the payers guns kills or nade kills. 
***************************************************************************/

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_GOLDEN 8192 
#define ACCESS_CONSOLE 131071
#define ON 1
#define OFF 0
#define YES 1
#define NO 0
#define CT 2
#define T 1


/****************************************************************************/
//Customize it.
//Makes players glow when golden gun mode is enabled on them. (ON or OFF)
new GoldenGunGlow = ON;

/****************************************************************************/

new STRING_VERSION[MAX_DATA_LENGTH] = "0.3";
new REALTIMEDAMAGE; 
new set_hitme[MAX_DATA_LENGTH] = "sm_sayformat 0=100=200=-1=0.55=0=0=1=0=0=6";
new goldenbulletmode[MAX_PLAYERS];

public sm_teamattack(HLCommand,HLData,HLUserName,UserIndex) {
	new eng_msg[MAX_DATA_LENGTH], aIndex,vIndex, msg[MAX_DATA_LENGTH];
	new aIndexS[4],vIndexS[4],junk[4],damageS[4], aName[MAX_NAME_LENGTH],vName[MAX_NAME_LENGTH]; 
	new aWONID, aUserID;
	convert_string(HLData,eng_msg,MAX_DATA_LENGTH);
	//SM_Damage - "receiver" "index_of_attacker" "damage" "aiming_at" "weapon" "team_attacking"
	strsplit(eng_msg, " ",vIndexS, 4, aIndexS, 4, damageS, 4, junk, 4, junk, 4, junk, 4); 			
	aIndex = strtonum(aIndexS);
	vIndex = strtonum(vIndexS);
	playerinfo(aIndex,aName,MAX_NAME_LENGTH,aUserID,aWONID);
	playerinfo(vIndex,vName,MAX_NAME_LENGTH);
		
	if(REALTIMEDAMAGE == ON) {
		exec(set_hitme); 
		snprintf(msg,MAX_DATA_LENGTH,"sm_tell2 ^"#%i^" ^"%s^" ^"5^" ",aUserID,damageS); 
		exec(msg); 
		}
	
	if(goldenbulletmode[aIndex] == YES) {
		slay(vName); 
	}
	
	return PLUGIN_CONTINUE;
}

public admin_goldengun(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	new pIndex,pName[MAX_NAME_LENGTH],msg[MAX_DATA_LENGTH];
	
	if(check_user(Data)==0) {
		selfmessage("Unrecognized player: ");
		selfmessage(Data);
		return PLUGIN_HANDLED;
	}
	else {
		get_username(Data,pName,MAX_NAME_LENGTH);
		get_userindex(Data,pIndex);
		if(goldenbulletmode[pIndex] == OFF) {
			goldenbulletmode[pIndex] = ON;
			if(GoldenGunGlow == ON) {
				glow(pName,200,193, 0);
			}
			snprintf(msg,MAX_DATA_LENGTH,"[ADMIN] %s Had Golden Gun Mode Enabled on them by a administrator.",pName); 
			say(msg);
			
		}
		else if(goldenbulletmode[pIndex] == ON) {
			goldenbulletmode[pIndex] = OFF;
			if(GoldenGunGlow == ON) {
				glow(pName,0,0, 0);
			}
			snprintf(msg,MAX_DATA_LENGTH,"[ADMIN] %s Had Golden Gun Mode Disabled on them by a administrator.",pName); 
			say(msg);
		}
	}
				
	return PLUGIN_HANDLED;
}

public admin_showdamage(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	if (REALTIMEDAMAGE == ON) {
		REALTIMEDAMAGE = OFF;
		selfmessage("Bullet Damage OFF");
	} else if(REALTIMEDAMAGE == OFF) {
		REALTIMEDAMAGE = ON;
		selfmessage("Bullet Damage ON");
		
	}
	return PLUGIN_HANDLED;
}

public plugin_init() {
	plugin_registerinfo("The Golden Gun Plugin","Gives people golden guns. www.olo.counter-strike.pl",STRING_VERSION);
	
	//ADMIN COMMANDS
	plugin_registercmd("admin_showdamage","admin_showdamage",ACCESS_GOLDEN,"admin_showdamage: Toggles Bullet Damage Status ON and OFF.");
	plugin_registercmd("admin_goldengun","admin_goldengun",ACCESS_GOLDEN,"admin_goldengun <playername>: Toggles Golden Gun Mode for player. ");
	
	//SM ACCESS
	plugin_registercmd("sm_teamattack","sm_teamattack",ACCESS_CONSOLE,"");
		
	//STATSME REGISTARS
	exec("sm_register SM_Damage ^"admin_command sm_teamattack^" bcd");
	
	return PLUGIN_CONTINUE;
}